%% robust_example.m

%% 
clear all
close all
rng('default') % ̏

%% s1.1
%% m~if̒`(one mass model)
s  = tf('s');   % vXZqs̒`
M = 1;          % 
Pn = 1/(M*s^2); % m~if(1/(Ms^2)

%% PD
% ߎ s/(0.01s+1) gp
alpha = -0.5;
K1 = alpha^2*M - 2*alpha*M*s/(0.01*s+1);
alpha = -2.5;
K2 = alpha^2*M - 2*alpha*M*s/(0.01*s+1);

%% m~ifɑ΂鉞vZ
Tn1 = feedback(Pn*K1,1);
Tn2 = feedback(Pn*K2,1);
figure(1)
step(Tn1,'--',Tn2,10)
ylim([0 1.4])
legend('\alpha = -0.5','\alpha = -2.5',4)
figure(2)
bodemag(Tn1,'--',Tn2)
legend('\alpha = -0.5','\alpha = -2.5')

%% s1.2
%% ۓf̒`
% ȉ ureal gāCϓp[^`
m1 = ureal('m1',0.8,'percent',10); % }10%̐ۓ
m2 = M - m1;                       % m1+m2=MƂ
k  = ureal('k',300,'percent',10);  % }10%̐ۓ
c  = ureal('c',1,'percent',10);    % }10%̐ۓ
% Two mass model̒`
P = (c*s+k)/(s^2*(m1*m2*s^2 + (m1+m2)*c*s + (m1+m2)*k));
% fW̒50ʂ̃fI
P = usample(P,50); 
figure(3)
bodemag(Pn,P,'--',{1e1,1e3});
legend('One mass system','Two mass system with perturbation',3)

%% s1.3
%% ۓfɑ΂鉞vZ
T1 = feedback(P*K1,1);
T2 = feedback(P*K2,1);
figure(4)
step(T1,'--',T2,10)
ylim([0 1.4])
legend('\alpha = -0.5','\alpha = -2.5',4)
figure(5)
nyquist(P*K1)
axis([-1.5 0.5 -1 1])
legend('\alpha = -0.5',3)
figure(6)
nyquist(P*K2)
axis([-1.5 0.5 -1 1])
legend('\alpha = -2.5',3)
